#include <jde.h>

#define b551005_c



/*****************************************************************************
 *    Source File:  b551005
 *
 *    Description:  IBM Retrieve Business Function Source File
 *
 *        History:
 *          Date        Programmer  SAR# - Description
 *          ----------  ----------  -------------------------------------------
 *   Author 10/8/2003   Unknown     Unknown  - Created  
 *
 * Copyright (c) J.D. Edwards World Source Company, 1996
 *
 * This unpublished material is proprietary to J.D. Edwards World Source Company.
 * All rights reserved.  The methods and techniques described herein are
 * considered trade secrets and/or confidential.  Reproduction or
 * distribution, in whole or in part, is forbidden except by express
 * written permission of J.D. Edwards World Source Company.
 ****************************************************************************/
/**************************************************************************
 * Notes:
 *
 **************************************************************************/

#include <b551005.h>
#include <F5501005.h>
#include <stdio.h>
#include <stdlib.h>
#include <io.h>


/**************************************************************************
 *  Business Function:  Retrieve_WBIAEvents
 *
 *        Description:  Retrieving IBM Events
 *
 *         Parameters:
 *           LPBHVRCOM           lpBhvrCom    Business Function Communications
 *           LPVOID              lpVoid       Void Parameter - DO NOT USE!
 *           LPDSD5501005        lpDS         Parameter Data Structure Pointer  
 *
 *************************************************************************/

JDEBFRTN (ID) JDEBFWINAPI Retrieve_WBIAEvents (LPBHVRCOM lpBhvrCom, LPVOID lpVoid, LPDSD5501005 lpDS)  
{
   /************************************************************************
    *  Variable declarations
    ************************************************************************/
	HENV			hEnv	=	NULL;
	HUSER			hUser	=	NULL;
	JDEDB_RESULT		rcode;
	HREQUEST		hRequest = NULL;

	ID                          idJDBReturn; 

	LPSELECT	lpSelect;
	int eventStatus = 0;
	
	char* objectName;

	F5501005 dsF5501005;
	FILE *myFile;

	DBREF		zDbRef = { 0 };
	NID pID[1] = {NID_EVT_STATUS};
	int updatedEvtStatus = 0;
	int count = 0;

	LPSORT lpSort = NULL;

	int nNumSort =2;
	

   /************************************************************************
    * Declare structures
    ************************************************************************/

   /************************************************************************
    * Declare pointers
    ************************************************************************/

   /************************************************************************
    * Check for NULL pointers
    ************************************************************************/
   if ((lpBhvrCom == (LPBHVRCOM) NULL) ||
       (lpVoid    == (LPVOID)    NULL) ||
       (lpDS      == (LPDSD5501005)	NULL))
   {
     jdeErrorSet (lpBhvrCom, lpVoid, (ID) 0, "4363", (LPVOID) NULL);
     return ER_ERROR;
   }
	lpSelect =(LPSELECT) jdeAllocReturnIfError(COMMON_POOL, 1 * sizeof(SELECTSTRUCT), MEM_ZEROINIT);
	
	if(lpSelect == NULL)
	{
		return (1);
	}

	lpSort = jdeAllocReturnIfError(COMMON_POOL, nNumSort * sizeof(SORTSTRUCT), MEM_ZEROINIT);

	if(lpSort == NULL)

	{

		return(1);

	}
   
	myFile = fopen("IBMEventsBFExecution.log","a+t");

	if(myFile == NULL){
	return(1);
	}

   /************************************************************************
    * Set pointers
    ************************************************************************/

   /************************************************************************
    * Main Processing
    ************************************************************************/
	

	idJDBReturn = JDB_InitBhvr(lpBhvrCom, &hUser, (char *)NULL, JDEDB_COMMIT_AUTO);
    	if (idJDBReturn == JDEDB_FAILED)
    	{
        	jdeSetGBRError (lpBhvrCom,lpVoid,(ID) 0,"078S");
		fclose(myFile);
        	return ER_ERROR;
    	}
	

	if ((rcode = JDB_InitEnv(&hEnv)) != JDEDB_PASSED)
	{
		
		fprintf(myFile, "JDB_InitEnvOvr failed (returned %d).\n", rcode);

		fclose(myFile);
		return (0);
	}

	if ((rcode = JDB_InitUser(hEnv, &hUser, NULL, JDEDB_COMMIT_AUTO)) != JDEDB_PASSED)
	{
		
		fprintf(myFile, "JDB_InitUser failed (returned %d)\n", rcode);
		fclose(myFile);
		return (0);
	}	

	if (JDB_OpenTable (hUser, NID_F5501005, 0, NULL, (ushort)0, NULL, &hRequest) != JDEDB_PASSED)
	{
		
		fprintf(myFile,"Failed to open database table '%s'\n", NID_F5501005);
		fclose(myFile);
		return (1);
	}
	
	eventStatus = lpDS->nEVENT_STATUS;

	
	fprintf(myFile, "EventStatus is:  %d\n", eventStatus);

	strcpy (lpSelect[0].Item1.szTable, NID_F5501005);
	lpSelect[0].Item1.idInstance	=	0;
	strcpy (lpSelect[0].Item2.szDict, "");
	strcpy (lpSelect[0].Item2.szTable, "");
	lpSelect[0].Item2.idInstance	=	0;
	lpSelect[0].nValues				=	1;
	lpSelect[0].nCmp				=	JDEDB_CMP_EQ;
	strcpy (lpSelect[0].Item1.szDict, NID_EVT_STATUS);
	lpSelect[0].lpValue				=	&eventStatus;	
	

	jdeNIDcpy(lpSort[0].Item.szDict , NID_EVT_PRTY);
	jdeNIDcpy(lpSort[0].Item.szTable , NID_F5501005);
	lpSort[0].Item.idInstance = 0;
	lpSort[0].nSort = JDEDB_SORT_ASC;

	jdeNIDcpy(lpSort[1].Item.szDict , NID_EVENT_ID);
	jdeNIDcpy(lpSort[1].Item.szTable , NID_F5501005);
	lpSort[1].Item.idInstance = 0;
	lpSort[1].nSort = JDEDB_SORT_ASC;


	// Set the selection information to empty
	if (JDB_ClearSelection (hRequest) != JDEDB_PASSED)
	{
		
		
		fprintf(myFile,"Failed to clear database selection.\n");

		fclose(myFile);
		jdeFree (lpSelect);
		return (1);
	}else 
	{
		
		fprintf(myFile,"Success to clear database selection.\n");
	}

	// Create WHERE clause
	if (JDB_SetSelection(hRequest, lpSelect, 1, JDEDB_SET_REPLACE) != JDEDB_PASSED)
	{
		
		fprintf (myFile, "Failed to set selection criteria\n");

		jdeFree (lpSelect);
		fclose(myFile);
		return (1);
	}else
	{
		
		fprintf(myFile,"Success to set selection criteria\n");
	}

	if (JDB_SetSequencing(hRequest, lpSort, 2, JDEDB_SET_REPLACE) != JDEDB_PASSED)
	{
		
		fprintf (myFile, "Failed to set sequencing criteria\n");
		jdeFree (lpSort);
		fclose(myFile);
		return (1);
	}else
	{
		
		fprintf(myFile,"Success to set sequencing criteria\n");
	}
	// Select the records
	
	if (JDB_SelectKeyedForUpdate (hRequest,(ID) 0, (void *) NULL, (ushort) 0, pID, 1) != JDEDB_PASSED)
	{
		
		fprintf (myFile, "Select keyed failed.\n");
		jdeFree (lpSelect);
		fclose(myFile);
		return (1);
	}		
	
	

	//if(JDB_FetchForUpdate(hRequest, (LPVOID)&dsF5501005, 0))
	while((JDB_FetchForUpdate(hRequest, (LPVOID)&dsF5501005, 0)) && (count <= 0))
	{
		//fprintf(myFile,"values are : <%d>\n", dsF5501005.xwevent_id);
		//fprintf(myFile,"values are : <%s>\n", dsF5501005.xwobj_name);
		
		strcpy(lpDS->szOBJECT_NAME, dsF5501005.xwobj_name);
		lpDS->nEVENT_ID=dsF5501005.xwevent_id;
		strcpy(lpDS->szOBJECT_VERB, dsF5501005.xwobj_verb);
		strcpy(lpDS->szOBJECT_KEY, dsF5501005.xwobj_key);
		
		lpDS->nEVENT_PRIORITY=dsF5501005.xwevt_prty;
		lpDS->nEVENT_STATUS=dsF5501005.xwevt_status;
		lpDS->jdEVENT_TIME=dsF5501005.xwevt_time;
		strcpy(lpDS->szADAPTER_ID,dsF5501005.xwadapter_id);
		strcpy(lpDS->szEVENT_DESCRIPTION,dsF5501005.xwevt_desc);	
		
		zDbRef.idInstance =0;
		jdeNIDcpy (zDbRef.szTable , NID_F5501005);
		jdeNIDcpy (zDbRef.szDict , NID_EVT_STATUS);

		//lpDS->nEVENT_STATUS = 5;
		updatedEvtStatus = 5;

		
		fprintf(myFile,"udpated status is : <%d>\n", updatedEvtStatus);		
		
		
		if (JDB_AssignColumnValue (hRequest, zDbRef, EVDT_INT , &updatedEvtStatus) != JDEDB_PASSED )
		{
			
			fprintf (myFile, "Assign column value failed.\n");
			jdeFree (lpSelect);
			return (1);
		}else
		{
				
				fprintf (myFile, "Assign cols succeeded.\n");
				JDB_CommitUser(hUser);
		}
		if (JDB_UpdateCurrent (hRequest, NID_F5501005, 0L, 0L, NULL, 0, NULL) != JDEDB_PASSED)
		{
			
			fprintf (myFile, "Update current failed.\n");
			jdeFree (lpSelect);
			return (1);
		}else{
			
			fprintf (myFile, "Update current succeeded.\n");
			count = count + 1;			
			strcpy(lpDS->szDS_MISC,"Fetched");
		}
		
		

	}
	

   /************************************************************************
    * Function Clean Up
    ************************************************************************/
		fclose(myFile);
		// Cleanup the databsae connection
		JDB_CloseTable (hRequest);

		JDB_FreeBhvr(hUser);
		JDB_FreeUser (hUser);
		JDB_FreeEnv (hEnv);

   return (0);
}

/* Internal function comment block */
/**************************************************************************
 *   Function:  Ixxxxxxx_a   // Replace "xxxxxxx" with source file number
 *                           // and "a" with the function name
 *      Notes:
 *
 *    Returns:
 *
 * Parameters:
 **************************************************************************/

