#!/bin/sh -x

# This script should be called from connector_manager.sh, and accepts the following parameters:
#  start_myconnector.sh <CONNECTORNAME> <SERVERNAME> <OPTIONAL ADDITIONAL PARAMETERS>
#
#  Any line that has the #   <-- Check on it should be reviewed for your connector
#
################################################
# General connector variable initialization section
# No changes should be necessary
# set CONNECTOR_TYPE  -- This is needed to differentate Java from C++ conncetors 
# set CONDIR  the directory where the specific connector resides, then change to this directory
# set CONNAME the name to be the application connector that is starting
# set SERVER  the server name to be the interchange that is being targeted
# set CONJAR to the fullpath of the connector .jar file.

  
CONNAME=$1
SERVER=$2

. ${CROSSWORLDS}/bin/CWConnEnv.sh

CONDIR=${CROSSWORLDS}/connectors/${CONNAME}
CONJAR=${CONDIR}/BIA_${CONNAME}.jar

################################################
# Connector specific variable initialization section
# Set your Connector agent here 

#Comment one of the next two sections in:

#For C++ connectors comment in the next two lines 
#CONNECTOR_TYPE="-d"
#CONNECTOR_AGENT=${CONNAME}

#For Java connectors comment in the next two lines    
CONNECTOR_TYPE="-l"
CONNECTOR_AGENT=com.ibm.adapters.oneworld.OneWorldAdapterAgent


# Set any connector specific Variables here, add the module jar files generated using GenJava
#CON_SPEC_JAR_ONE=${CONDIR}/dependencies/Connector.jar:${CONDIR}/dependencies/Kernel.jar:${CROSSWORLDS}/lib/xerces.jar:${CONDIR}/dependencies/IBMEventsInterop.jar:


# Set Conn specific classpath here 
#Any specific variables defined above need to be added to the CON_SPECIFIC_CLASSPATH below.
CON_SPECIFIC_CLASSPATH=${CON_SPEC_JAR_ONE}                   #   <-- Check

# Set any Connector specific start options here
# CON_START_OPTIONS=" -tMAIN_SINGLE_THREADED "


# We are using the JVM_FLAGS that are aet in the CWSharedenv.sh file, if you need to use different flags,
#  Change $JVM_FLAGS to be what you need to use.
# No changes should be necessary below this line.

if [ -f ${CROSSWORLDS}/wbiart/wbiart.jar ]
then

JCLASSES=${CONJAR}:${CON_SPECIFIC_CLASSPATH}:${CWCLASSES}:${CONDIR}:${JCLASSES}
export JCLASSES

JVMArgs=-Dconfig_file=${CONDIR}/dependencies/jdeinterop.ini
export JVMArgs

ExtDirs=${CONDIR}/dependencies:${CONDIR}/repository:${ExtDirs}
export ExtDirs

exec start_adapter.sh ${CONNECTOR_TYPE}${CONNECTOR_AGENT} -n${CONNAME}Connector -s${SERVER} ${CON_START_OPTIONS} $3 $4 $5 $6 $7 $8 $9

else


CWCLASSES=${CWCLASSES}
CLASSPATH=${CONJAR}:${CON_SPECIFIC_CLASSPATH}:${CWCLASSES}:${CONDIR}
echo $CLASSPATH

${CROSSWORLDS}/bin/check_path.sh "$CLASSPATH"
exec ${CWJAVA} ${JVM_FLAGS} -Dconfig_file=${CONDIR}/dependencies/jdeinterop.ini -Djava.library.path=${LD_LIBRARY_PATH}:${CONDIR}/dependencies:${CONDIR}/repository -Djava.ext.dirs=${JRE_EXT_DIRS}:${CONDIR}/dependencies:${CONDIR}/repository -classpath ${CLASSPATH} AppEndWrapper ${CONNECTOR_TYPE}${CONNECTOR_AGENT} -n${CONNAME}Connector -s${SERVER} $3 $4 $5 $6 $7 $8 $9
fi
